# Class SimpleTypeVisitorPreview<R,P>

java.lang.Object
javax.lang.model.util.AbstractTypeVisitor6<R,P>
javax.lang.model.util.SimpleTypeVisitor6<R,P>
javax.lang.model.util.SimpleTypeVisitor7<R,P>
javax.lang.model.util.SimpleTypeVisitor8<R,P>
javax.lang.model.util.SimpleTypeVisitor9<R,P>
javax.lang.model.util.SimpleTypeVisitor14<R,P>
javax.lang.model.util.SimpleTypeVisitorPreview<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `TypeVisitor<R,P>`

@SupportedSourceVersion(RELEASE_26) public class SimpleTypeVisitorPreview<R,P> extends SimpleTypeVisitor14<R,P>
`SimpleTypeVisitorPreview` is a reflective preview API of the Java platform.
Preview features may be removed in a future release, or upgraded to permanent features of the Java platform.
A simple visitor of types with default behavior appropriate for a preview source version. Visit methods corresponding to `RELEASE_14` and earlier language constructs call `defaultAction`, passing their arguments to `defaultAction`'s corresponding parameters.

API Note:
  Methods in this class may be overridden subject to their general contract.
Since:
  23
See Also:
  - Expected visitor evolution
  - Compatibility note for subclasses
  - `SimpleTypeVisitor6`
  - `SimpleTypeVisitor7`
  - `SimpleTypeVisitor8`
  - `SimpleTypeVisitor9`
  - `SimpleTypeVisitor14`

- ## Field Summary

  ### Fields declared in class SimpleTypeVisitor6

  `DEFAULT_VALUE`
  Modifier and Type
  Field
  Description
  `protected final R`
  `DEFAULT_VALUE`
  Default value to be returned; `defaultAction` returns this value unless the method is overridden.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `SimpleTypeVisitorPreview()`
  Constructor for concrete subclasses; uses `null` for the default value.
  `protected`
  `SimpleTypeVisitorPreview(R defaultValue)`
  Constructor for concrete subclasses; uses the argument for the default value.

- ## Method Summary

  ### Methods declared in class SimpleTypeVisitor8

  `visitIntersection`
  Modifier and Type
  Method
  Description
  `R`
  `visitIntersection(IntersectionType t, P p)`
  Visits an intersection type.

  ### Methods declared in class SimpleTypeVisitor7

  `visitUnion`
  Modifier and Type
  Method
  Description
  `R`
  `visitUnion(UnionType t, P p)`
  Visits a union type.

  ### Methods declared in class SimpleTypeVisitor6

  `defaultAction, visitArray, visitDeclared, visitError, visitExecutable, visitNoType, visitNull, visitPrimitive, visitTypeVariable, visitWildcard`
  Modifier and Type
  Method
  Description
  `protected R`
  `defaultAction(TypeMirror t, P p)`
  The default action for visit methods.
  `R`
  `visitArray(ArrayType t, P p)`
  Visits an array type.
  `R`
  `visitDeclared(DeclaredType t, P p)`
  Visits a declared type.
  `R`
  `visitError(ErrorType t, P p)`
  Visits an error type.
  `R`
  `visitExecutable(ExecutableType t, P p)`
  Visits an executable type.
  `R`
  `visitNoType(NoType t, P p)`
  Visits a `NoType` instance.
  `R`
  `visitNull(NullType t, P p)`
  Visits the null type.
  `R`
  `visitPrimitive(PrimitiveType t, P p)`
  Visits a primitive type.
  `R`
  `visitTypeVariable(TypeVariable t, P p)`
  Visits a type variable.
  `R`
  `visitWildcard(WildcardType t, P p)`
  Visits a wildcard type.

  ### Methods declared in class AbstractTypeVisitor6

  `visit, visit, visitUnknown`
  Modifier and Type
  Method
  Description
  `final R`
  `visit(TypeMirror t)`
  Visits any type mirror as if by passing itself to that type mirror's `accept` method and passing `null` for the additional parameter.
  `final R`
  `visit(TypeMirror t, P p)`
  Visits any type mirror as if by passing itself to that type mirror's `accept` method.
  `R`
  `visitUnknown(TypeMirror t, P p)`
  Visits an unknown kind of type.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### SimpleTypeVisitorPreview

    protected SimpleTypeVisitorPreview()
    Constructor for concrete subclasses; uses `null` for the default value.

  - ### SimpleTypeVisitorPreview

    protected SimpleTypeVisitorPreview(R defaultValue)
    Constructor for concrete subclasses; uses the argument for the default value.
    Parameters:
      `defaultValue` - the value to assign to `SimpleTypeVisitor6.DEFAULT_VALUE`